searchNodes=[{"doc":"Context for interfacing with Google&#39;s Public certificates. For practical usage examples see our documentation on how to use with the joken library See Google&#39;s documentation on verify the integrity of the id token for more details.","ref":"GoogleCerts.html","title":"GoogleCerts","type":"module"},{"doc":"Returns the algorithm and certificate for a given kid. Examples iex&gt; GoogleCerts.fetch(&quot;257f6a5828d1e4a3a6a03fcd1a2461db9593e624&quot;) {:ok, &quot;RS256&quot;, %{ &quot;alg&quot; =&gt; &quot;RS256&quot;, &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;257f6a5828d1e4a3a6a03fcd1a2461db9593e624&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;kXPOxGSWngQ6Q02jhaJfzSum2FaU5_6e6irUuiwZbgUjyN2Q1VYHwuxq2o-aHqUhNPqf2cyCf2HspYwKAbeK9gFXqScrGLPW5pcquOWOVYUzPw87lBGH2fSxCYH35eB14wfLmF_im8DLTtZsaJvMRbqBgikM8Km2UA9ozjfK6E8pWW91fIT-ZF4Qy5zDkT3yX8EnAIMOuXg43v4t03FwFTyF4D9IET2ri2_n2qDhWTgtxJ0FHk3wG2KXdJIIVy2kUCTzMcZKaamRgUExt3Mu_z-2eyny8b6IdLPEIGF51VCgHebPQXE5iZmLGyw6M_pCApGJUw5GpXi6imo3pOvLjQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; } }","ref":"GoogleCerts.html#fetch/1","title":"GoogleCerts.fetch/1","type":"function"},{"doc":"Returns the currently stored GoogleCerts.Certifcates. Examples iex&gt; GoogleCerts.get() %GoogleCerts.Certifcates{ algorithm: &quot;RS256&quot;, certs: [ %GoogleCerts.Certificate{ cert: %{ &quot;alg&quot; =&gt; &quot;RS256&quot;, &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;6fcf413224765156b48768a42fac06496a30ff5a&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;1sUr077w2aaSnm08qFmuH1UON9e2n6vDNlUxm6WgM95n0_x1GwWTrhXtd_6U6x6R6m-50mVS_ki2BHZ9Fj3Y9W5zBww_TNyNLp4b1802gbXeGhVtQMcFQQ-hFne5HaTVTi1y6QNbu_3V1NW6nNAbpR_t79l1WzGiN4ilFiYFU0OVjk7isf7Dv3-6Trz9riHBExl34qhriu3x5pfipPT1rf4J6jMroJTEeU6L7zd9k_BwjNtptS8wAenYaK4FENR2gxvWWTX40i548Sh-3Ffprlu_9CZCswCkQCdhTq9lo3DbZYPEcW4aOLBEi3FfLiFm-DNDK_P_gBtNz8gW3VMQ2w&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }, kid: &quot;6fcf413224765156b48768a42fac06496a30ff5a&quot; }, %GoogleCerts.Certificate{ cert: %{ &quot;alg&quot; =&gt; &quot;RS256&quot;, &quot;e&quot; =&gt; &quot;AQAB&quot;, &quot;kid&quot; =&gt; &quot;257f6a5828d1e4a3a6a03fcd1a2461db9593e624&quot;, &quot;kty&quot; =&gt; &quot;RSA&quot;, &quot;n&quot; =&gt; &quot;kXPOxGSWngQ6Q02jhaJfzSum2FaU5_6e6irUuiwZbgUjyN2Q1VYHwuxq2o-aHqUhNPqf2cyCf2HspYwKAbeK9gFXqScrGLPW5pcquOWOVYUzPw87lBGH2fSxCYH35eB14wfLmF_im8DLTtZsaJvMRbqBgikM8Km2UA9ozjfK6E8pWW91fIT-ZF4Qy5zDkT3yX8EnAIMOuXg43v4t03FwFTyF4D9IET2ri2_n2qDhWTgtxJ0FHk3wG2KXdJIIVy2kUCTzMcZKaamRgUExt3Mu_z-2eyny8b6IdLPEIGF51VCgHebPQXE5iZmLGyw6M_pCApGJUw5GpXi6imo3pOvLjQ&quot;, &quot;use&quot; =&gt; &quot;sig&quot; }, kid: &quot;257f6a5828d1e4a3a6a03fcd1a2461db9593e624&quot; } ], expire: &quot;2020-04-10T03:40:42.616266Z&quot;, version: 3 }","ref":"GoogleCerts.html#get/0","title":"GoogleCerts.get/0","type":"function"},{"doc":"Returns a GoogleCerts.Certifcates that is not expired. If the provided certificates are not expired, then the same certificates are returned. If the provided certificates are expired, then new certificates are retrieved via an HTTP request. The certificates returned will always be the same version as the certificates provided.","ref":"GoogleCerts.html#refresh/1","title":"GoogleCerts.refresh/1","type":"function"},{"doc":"Struct to associate a kid to a certificate map. kid is the id and cert can either be a map with a pem or a JWK map version 1 cert is %{&quot;pem&quot; =&gt; &quot;-----BEGIN CERTIFICATE----- ...&quot;} version 3 cert is %{&quot;kid&quot; =&gt; &quot;53c66aab5...&quot;. &quot;e&quot; =&gt; &quot;AQAB&quot;, ...}","ref":"GoogleCerts.Certificate.html","title":"GoogleCerts.Certificate","type":"module"},{"doc":"","ref":"GoogleCerts.Certificate.html#decode!/1","title":"GoogleCerts.Certificate.decode!/1","type":"function"},{"doc":"","ref":"GoogleCerts.Certificate.html#t:t/0","title":"GoogleCerts.Certificate.t/0","type":"type"},{"doc":"","ref":"GoogleCerts.Certificate.html#t:t/2","title":"GoogleCerts.Certificate.t/2","type":"type"},{"doc":"Agent to hold the current public certs that google uses to sign JWTs","ref":"GoogleCerts.CertificateCache.html","title":"GoogleCerts.CertificateCache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"GoogleCerts.CertificateCache.html#child_spec/1","title":"GoogleCerts.CertificateCache.child_spec/1","type":"function"},{"doc":"","ref":"GoogleCerts.CertificateCache.html#get/0","title":"GoogleCerts.CertificateCache.get/0","type":"function"},{"doc":"","ref":"GoogleCerts.CertificateCache.html#start_link/1","title":"GoogleCerts.CertificateCache.start_link/1","type":"function"},{"doc":"Struct that holds a list of Google.Oauth2.Certificate structs with their expiration time algorithm and version","ref":"GoogleCerts.Certificates.html","title":"GoogleCerts.Certificates","type":"module"},{"doc":"","ref":"GoogleCerts.Certificates.html#add_cert/3","title":"GoogleCerts.Certificates.add_cert/3","type":"function"},{"doc":"Returns a GoogleCerts.Certificates from the provided json or raw elixir map","ref":"GoogleCerts.Certificates.html#decode!/1","title":"GoogleCerts.Certificates.decode!/1","type":"function"},{"doc":"Returns true if expire is is less than the current UTC time.","ref":"GoogleCerts.Certificates.html#expired?/1","title":"GoogleCerts.Certificates.expired?/1","type":"function"},{"doc":"Returns a GoogleCerts.Certificate for a given kid that is in certs","ref":"GoogleCerts.Certificates.html#find/2","title":"GoogleCerts.Certificates.find/2","type":"function"},{"doc":"","ref":"GoogleCerts.Certificates.html#set_expiration/2","title":"GoogleCerts.Certificates.set_expiration/2","type":"function"},{"doc":"","ref":"GoogleCerts.Certificates.html#set_version/2","title":"GoogleCerts.Certificates.set_version/2","type":"function"},{"doc":"","ref":"GoogleCerts.Certificates.html#t:t/0","title":"GoogleCerts.Certificates.t/0","type":"type"},{"doc":"","ref":"GoogleCerts.Certificates.html#t:t/4","title":"GoogleCerts.Certificates.t/4","type":"type"},{"doc":"","ref":"GoogleCerts.CertificateDecodeException.html","title":"GoogleCerts.CertificateDecodeException","type":"exception"},{"doc":"Google Certificates A Lightweight GenServer that stores and caches Google&#39;s Public Certificates. The Google Certificates library makes it easy to verify and validate a JWT issued by Google. See the how to use with the joken library section below for an example on how to accomplish this using this library combined with the Joken library. For more details, see Google&#39;s backend-auth documentation, specifically the verify the integrity of the id token section. The default behavior is to use the JWK format (/oauth2/v3/certs) for certificates, but the PEM (/oauth2/v1/certs) format can be used if specified.","ref":"readme.html","title":"Google Certificates","type":"extras"},{"doc":"This package can be installed by adding google_certs to your list of dependencies in mix.exs: def deps do [ {:google_certs, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Google Certificates - Installation","type":"extras"},{"doc":"GoogleCerts.CertificateCache is an Agent so you can simply add it to your supervision tree and Google&#39;s certificates will be downloaded and cached on startup. use Application alias GoogleCerts.CertificateCache def start(_type, _args) do children = [ CertificateCache ] opts = [strategy: :one_for_one, name: Directory.Supervisor] Supervisor.start_link(children, opts) end There are three publicity available functions that are helpful. GoogleCerts.get/0- Get cached certificates GoogleCerts.fetch/1 - Get a certificate by it&#39;s kid (useful with Joken.peek_header/1 to and Joken.Signer.create/3 to create a signer) GoogleCerts.refresh/1 - Refresh a GoogleCerts.Certificates struct if the certificates are expired. Intended for internal use. iex&gt; GoogleCerts.get() # get all certificates iex&gt; GoogleCerts.fetch(&quot;257f6a5828d1e4a3a6a03fcd1a2461db9593e624&quot;) # get a certificate by its kid iex&gt; GoogleCerts.refresh(%GoogleCerts.Certificates{}) # refresh a set of certificates if they are expired","ref":"readme.html#usage","title":"Google Certificates - Usage","type":"extras"},{"doc":"Create a custom verify hook Register your custom verify hook with your JWTManager (custom module that use Joken.Config ) Use your JWTManager to verify and validate a JWT issued from Google. See ueberauth and ueberauth_google packages for retrieving a JWT from Google as part of your authentication. Create a custom verify hook defmodule Crypto.VerifyHook do @moduledoc false use Joken.Hooks @impl true def before_verify(_options, {jwt, %Joken.Signer{} = _signer}) do with {:ok, %{&quot;kid&quot; =&gt; kid}} &lt;- Joken.peek_header(jwt), {:ok, algorithm, key} &lt;- GoogleCerts.fetch(kid) do {:cont, {jwt, Joken.Signer.create(algorithm, key)}} else error -&gt; {:halt, {:error, :no_signer}} end end end Register your custom verify hook with your JWTManager defmodule Crypto.JWTManager do @moduledoc false use Joken.Config, default_signer: nil @iss &quot;https://accounts.google.com&quot; # your google client id (usually ends in *.apps.googleusercontent.com) defp aud, do: Application.get_env(:my_app, :google_client_id) # reference your custom verify hook here add_hook(Crypto.VerifyHook) @impl Joken.Config def token_config do default_claims(skip: [:aud, :iss]) |&gt; add_claim(&quot;iss&quot;, nil, &amp;(&amp;1 == @iss)) |&gt; add_claim(&quot;aud&quot;, nil, &amp;(&amp;1 == aud())) end end Use your JWTManager to verify and validate a JWT issued from Google iex&gt; jwt = &quot;eyJhbGciOiJSUzI1...&quot; iex&gt; {:ok, claims} = JWTManager.verify_and_validate(jwt)","ref":"readme.html#how-to-use-with-the-joken-library","title":"Google Certificates - How to use with the Joken library","type":"extras"},{"doc":"# config/config.exs config :google_certs, version: 1 # Use PEM format instead of JWK format. defaults to 3 for JWK","ref":"readme.html#configuration-optional","title":"Google Certificates - Configuration (Optional)","type":"extras"}]